﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using BA.ECommerce.DataContracts;

namespace BA.ECommerce
{

    public sealed class GetLowestQuote : CodeActivity<PriceQuote>
    {
        public InArgument<List<PriceQuote>> Quotes { get; set; }
        public InArgument<string > ProductId { get; set; }

        protected override PriceQuote Execute(CodeActivityContext context)
        {
            var productId = context.GetValue(this.ProductId);
            var quotes = context.GetValue(this.Quotes);

            var quote = new PriceQuote
            {
                Price = 0.0M
                ,
                VendorId = "None"
                ,
                ProductId = productId
            };

            quote = quotes.Aggregate(
                quote, (last, next) =>
                    last.VendorId == "None" || next.Price < last.Price 
                        ? next 
                        : last);
            
            return quote;
        }
    }
}
