﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using BA.ECommerce.DataContracts;

namespace VendorB.ECommerce
{

    public sealed class CalculateQuote : CodeActivity<PriceQuote>
    {
        public InArgument<string> ProductId { get; set; }

        protected override PriceQuote Execute(CodeActivityContext context)
        {
            var productId = context.GetValue(this.ProductId);

            Decimal price;

            switch(productId)
            {
                case "1001":
                    price = 991.99M;
                    break;
                case "1002":
                    price = 992.99M;
                    break;
                case "1003":
                    price = 993.99M;
                    break;
                case "1004":
                    price = 993.99M;
                    break;
                case "666":
                    throw new ArgumentException("This product is evil. Begone!");
                default:
                    price = 42.00M;
                    break;
            }

            return new PriceQuote
                       {
                           Price = price
                           ,
                           VendorId = "B"
                           ,
                           ProductId = productId
                       };
        }
    }
}
