﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using System.Threading;
using BA.ECommerce.DataContracts;

namespace VendorC.ECommerce
{

    public sealed class CreatePriceQuote : CodeActivity<PriceQuote>
    {
        public InArgument<string> ProductId{ get; set; }

        protected override PriceQuote Execute(CodeActivityContext context)
        {
            string productId = context.GetValue(this.ProductId);

            Decimal price;

            switch (productId)
            {
                case "1001":
                    price = 3331.99M;
                    break;
                case "1002":
                    price = 333332.99M;
                    break;
                case "1003":
                    price = 3.99M;
                    break;
                case "1004":
                    Thread.Sleep(50000);
                    price = 3.99M;
                    break;
                case "666":
                    throw new ArgumentException("This product is evil. Begone!");
                default:
                    price = 0.00M;
                    break;
            }

            return new PriceQuote
            {
                VendorId = "C"
                ,
                Price = price
                ,
                ProductId = productId
            };
        }
    }
}
